import { ViewBase } from '../../libappbase/viewbase';
import { AppMP } from '../appmp';
import { UIWaitSOP } from '../../libappsop/objectsop';
import { FormScenarioAnalysisUnitCapacity } from '../forms/form.scenarioanalysisunitcapacity';

/**
 * Scenario Analysis > Unit Capacity
 */
export class ViewScenarioAnalysisUnitCapacity extends ViewBase implements UIWaitSOP {
  public readonly name = 'Unit capacity'; // View name as seen in software Configure Views dialog
  public readonly viewPath = 'Scenario Analysis > Unit Capacity';

  public formScenarioAnalysisUnitCapacity = new FormScenarioAnalysisUnitCapacity();

  /**
   * Switch to Scenario Analysis > Unit Capacity
   */
  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();
    // Click Scenario Analysis action bar page
    await appMP.abpScenarioAnalysis.click();
    // Click open Unit Capacity view
    await appMP.abpScenarioAnalysis.btnUnitCapacity.click();
    await this.waitUILoaded();
    }

  public async waitUILoaded(): Promise<void> {
    await this.formScenarioAnalysisUnitCapacity.waitUntilPresent();
  }
}
